<?php
/***********************************
* NoNo-ServeuR.net
* Script v2
* network_downloadfromwebserver($url,$downloadpath,optionnal $filename,optionnal $ftptimeout,optionnal $buffersize) ---> Return false if fail or array(filename,size in b,download url,download path,download duration in s,averange download speed in b)
* $url : the file of client download
* $downloadpath : download to ???, create it if not exist
* $ftptimeout : if using ftp protocol , 2s by default
buffersize : for performance tweek
************************************/

function network_downloadfromwebserver($url,$downloadpath,$filename = '',$ftptimeout = 2,$buffersize = 8192){
	if(substr(strtolower($url),0,5)!=='https' && substr(strtolower($url),0,4)!=='http' && substr(strtolower($url),0,3)!=='ftp' && substr(strtolower($url),0,4)!=='ftps'){return false;} //check url format
	if(substr(strtolower($url),0,3)=='ftp' || substr(strtolower($url),0,4)=='ftps'){$is_ftp = true;} //for filesize function
	
	set_time_limit(0); //set execution limit time to 0
	if(!file_exists($downloadpath)){mkdir($downloadpath);} //if download folder not exist create it
	
	if($is_ftp){ //if ftp
		$protocole = reset(end(explode('://',$url))); //ftp or ftps
		$hostnamewuser = reset(explode('/',end(explode('://',$url)))); //extract hostname with user,pass and port if set
		$ftphost = reset(explode(':',end(explode('@',$ftpfullhost)))); //host without user,pass and port
		$ftpuser = explode('@',$hostnamewuser); //to detect user and pass
		if(count($ftpuser)>1){$ftpuser = explode(':',$ftpuser[0]);}else{$ftpuser = false;} //get user and pass
		$ftpport = explode(':',$ftpfullhost); //to detect port
		if(count($ftpport)>1){$ftpport = end($ftpport);}else{$ftpport = 21;} //get port
		
		$ftpstream = ftp_connect($ftphost,$ftpport,$ftptimeout); //open ftp connection
		if($ftpuser !== false){ftp_login($ftpstream,$ftpuser[0],$ftpuser[1]);} //if ftp user set
		$filesize = ftp_size($ftpstream,str_replace("$protocole://$hostnamewuser",'',$url)); //get filesize
		ftp_close($ftpstream); //close ftp connection
	}else{ //if http
		$filesize = array_change_key_case(get_headers($url, 1));//get http header
		$filesize = $filesize['content-length'];//get filesize
	}
	
	if($filesize<1){return false;} //if filesize not found
	$filesize = sprintf("%u", $filesize); //if filesize > 2gb
	
	if($filename==''){$filename = end(explode('/',$url));} //get filename from url if not set
	$urlfilename = end(explode('/',$url)); //get filename from url 
	
	$starttime = microtime(true); //get start time for stats

	$fr = fopen($url, "r"); //open read stream
	$fw = fopen($downloadpath.'/'.$filename, "w"); //open write stream
	while(!feof($fr)){
		fwrite($fw,fread($fr,$buffersize)); //write readen data
	}
	fclose ($fr); //close read stream
	fclose ($fw); //close write stream
	
	$endtime = microtime(true); //get end time for stats
	
	if($filesize == filesize($downloadpath.'/'.$filename)){
		$totaltime = $endtime-$starttime; //stats
		$avrspeed = round($filesize/$totaltime); //stats
		return array($urlfilename,$filesize,$url,$downloadpath.'/'.$filename,round($totaltime,2),$avrspeed); //return info
	}else{
		return false;
	}
}


//######################### DEMO ############################################
//print_r(network_downloadfromwebserver("http://fr.3planesoft.com/files/the_one_ring.exe","./dl"));
echo "<pre>\n";
$filedowninfo = network_downloadfromwebserver("http://fr.3planesoft.com/files/the_one_ring.exe","./dl");
echo "Filename -> " . $filedowninfo[0]."<br />\n";
echo "Size -> " . $filedowninfo[1]."b (" . round($filedowninfo[1]/1024,2) . "kb)<br />\n";
echo "Download from -> " . $filedowninfo[2]."<br />\n";
echo "To -> " . $filedowninfo[3]."<br />\n";
echo "Duration -> " . $filedowninfo[4]."s<br />\n";
echo "Averange download speed -> " . $filedowninfo[5]."b/s (" . round($filedowninfo[5]/1024,2) . "kb)<br />\n";
echo "</pre>\n";
?>